<?php
/*
Plugin Name: Batch Manager Prefilters ratio
Version: 11.0.a
Description: Add ration image prefilters in Batch Manager.
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=734
Author: Miklfe
Author URI: http://www.piwitheme.fr
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

  add_event_handler('get_batch_manager_prefilters', 'mps_add_batch_manager_prefilters');
  add_event_handler('perform_batch_manager_prefilters', 'mps_perform_batch_manager_prefilters', EVENT_HANDLER_PRIORITY_NEUTRAL, 2);

  load_language('plugin.lang', dirname(__FILE__).'/');


/**
 * add a prefilter to the Batch Downloader
 */
function mps_add_batch_manager_prefilters($prefilters)
{
	array_push($prefilters, array(
    'ID' => 'mps3.2',
    'NAME' => l10n('ratio of the image 3/2'),
  ));
	array_push($prefilters, array(
    'ID' => 'mps4.3',
    'NAME' => l10n('ratio of the image 4/3'),
  ));
	array_push($prefilters, array(
    'ID' => 'mps16.9',
    'NAME' => l10n('ratio of the image 16/9'),
  ));
	array_push($prefilters, array(
    'ID' => 'mpssquare',
    'NAME' => l10n('ratio of the image square'),
  ));
  
	return $prefilters;
}

/**
 * perform added prefilter
 */
function mps_perform_batch_manager_prefilters($filter_sets, $prefilter)
{
if ($prefilter == 'mps3.2')
	{
 $ratios = array(
	1.47,
	1.53,
	0.63,
	0.69
	);
 $res= filter_sets_image_format($ratios);
 $filter_sets[] = $res;	
	}
	
if ($prefilter == 'mps4.3')
	{
 $ratios = array(
	1.3,
	1.4,
	0.72,
	0.78
	);
 $res= filter_sets_image_format($ratios);
 $filter_sets[] = $res;	
	}
	
if ($prefilter == 'mps16.9')
	{
 $ratios = array(
	1.74,
	1.80,
	0.53,
	0.59
	);
 $res= filter_sets_image_format($ratios);
 $filter_sets[] = $res;	
	}

if ($prefilter == 'mpssquare')
	{
 $ratios = array(
	0.97,
	1.03,
	0.97,
	1.03
	);
 $res= filter_sets_image_format($ratios);
 $filter_sets[] = $res;	
	}
	
	return $filter_sets;
}

function filter_sets_image_format($ratios)
{
  $res = array();
  
   $query = '
   SELECT id, width, height
   FROM '.IMAGES_TABLE.'
   ;';
   	
   $result = pwg_query($query);
   if (pwg_db_num_rows($result))
   {
    while ($row = pwg_db_fetch_assoc($result))
    {
    if ($row['width']>0 && $row['height']>0)
     {
     $ratio = floor($row['width'] / $row['height'] * 100) / 100;
   		
    if(($ratio > $ratios[0] && $ratio < $ratios[1]) || ($ratio > $ratios[2] && $ratio < $ratios[3]))
     {
      $res[] = $row['id']; 
     }
   	}
   }
 }
	return $res;
}

?>